# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Support::Mgmt::V2020_04_01
  module Models
    #
    # Contact information associated with the support ticket.
    #
    class ContactProfile

      include MsRestAzure

      # @return [String] First name.
      attr_accessor :first_name

      # @return [String] Last name.
      attr_accessor :last_name

      # @return [PreferredContactMethod] Preferred contact method. Possible
      # values include: 'email', 'phone'
      attr_accessor :preferred_contact_method

      # @return [String] Primary email address.
      attr_accessor :primary_email_address

      # @return [Array<String>] Additional email addresses listed will be
      # copied on any correspondence about the support ticket.
      attr_accessor :additional_email_addresses

      # @return [String] Phone number. This is required if preferred contact
      # method is phone.
      attr_accessor :phone_number

      # @return [String] Time zone of the user. This is the name of the time
      # zone from [Microsoft Time Zone Index
      # Values](https://support.microsoft.com/help/973627/microsoft-time-zone-index-values).
      attr_accessor :preferred_time_zone

      # @return [String] Country of the user. This is the ISO 3166-1 alpha-3
      # code.
      attr_accessor :country

      # @return [String] Preferred language of support from Azure. Support
      # languages vary based on the severity you choose for your support
      # ticket. Learn more at [Azure Severity and
      # responsiveness](https://azure.microsoft.com/support/plans/response).
      # Use the standard language-country code. Valid values are 'en-us' for
      # English, 'zh-hans' for Chinese, 'es-es' for Spanish, 'fr-fr' for
      # French, 'ja-jp' for Japanese, 'ko-kr' for Korean, 'ru-ru' for Russian,
      # 'pt-br' for Portuguese, 'it-it' for Italian, 'zh-tw' for Chinese and
      # 'de-de' for German.
      attr_accessor :preferred_support_language


      #
      # Mapper for ContactProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ContactProfile',
          type: {
            name: 'Composite',
            class_name: 'ContactProfile',
            model_properties: {
              first_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'firstName',
                type: {
                  name: 'String'
                }
              },
              last_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'lastName',
                type: {
                  name: 'String'
                }
              },
              preferred_contact_method: {
                client_side_validation: true,
                required: true,
                serialized_name: 'preferredContactMethod',
                type: {
                  name: 'String'
                }
              },
              primary_email_address: {
                client_side_validation: true,
                required: true,
                serialized_name: 'primaryEmailAddress',
                type: {
                  name: 'String'
                }
              },
              additional_email_addresses: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalEmailAddresses',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              phone_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'phoneNumber',
                type: {
                  name: 'String'
                }
              },
              preferred_time_zone: {
                client_side_validation: true,
                required: true,
                serialized_name: 'preferredTimeZone',
                type: {
                  name: 'String'
                }
              },
              country: {
                client_side_validation: true,
                required: true,
                serialized_name: 'country',
                type: {
                  name: 'String'
                }
              },
              preferred_support_language: {
                client_side_validation: true,
                required: true,
                serialized_name: 'preferredSupportLanguage',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
