# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Support::Mgmt::V2020_04_01
  module Models
    #
    # Additional set of information required for quota increase support ticket
    # for certain quota types, e.g.: Virtual machine cores. Get complete
    # details about Quota payload support request along with examples at
    # [Support quota request](https://aka.ms/supportrpquotarequestpayload).
    #
    class QuotaTicketDetails

      include MsRestAzure

      # @return [String] Required for certain quota types when there is a sub
      # type, such as Batch, for which you are requesting a quota increase.
      attr_accessor :quota_change_request_sub_type

      # @return [String] Quota change request version.
      attr_accessor :quota_change_request_version

      # @return [Array<QuotaChangeRequest>] This property is required for
      # providing the region and new quota limits.
      attr_accessor :quota_change_requests


      #
      # Mapper for QuotaTicketDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'QuotaTicketDetails',
          type: {
            name: 'Composite',
            class_name: 'QuotaTicketDetails',
            model_properties: {
              quota_change_request_sub_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'quotaChangeRequestSubType',
                type: {
                  name: 'String'
                }
              },
              quota_change_request_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'quotaChangeRequestVersion',
                type: {
                  name: 'String'
                }
              },
              quota_change_requests: {
                client_side_validation: true,
                required: false,
                serialized_name: 'quotaChangeRequests',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'QuotaChangeRequestElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'QuotaChangeRequest'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
